
#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>

#define  __THE_DLL__
#include "DrvMercFR.h"

#pragma argsused

//#define password4

extern "C"
{

  int  __declspec(dllexport)  __stdcall Connect(
         unsigned char PortNum,
         unsigned short BaudRate,
         unsigned short Timeout,
         char     *psw);

  int  __declspec(dllexport) __stdcall Disconnect();


  int  __declspec(dllexport) __stdcall RegisterOper(
         int OperNum,
         char *OperName );
  int  __declspec(dllexport) __stdcall SendText(
         char *Text );


  int  __declspec(dllexport) __stdcall GetCurrOper(int *OperNum);

  int  __declspec(dllexport) __stdcall GetTaxNum(int *TaxNum);

  int  __declspec(dllexport) __stdcall GetTaxRate(
         int TaxIndex,
         int *TaxVal,
         char *Name);

  int  __declspec(dllexport) __stdcall OpenReceipt(int OperType);

  int  __declspec(dllexport) __stdcall  AddRecEntry(
         double Price,            //  /
         int Quantity,            // 
         int  QuantityPrec,       //  
         double Sum,              //  (   )
         int Depart,              // 
         int TaxIndex,            //  
         int Code,                // 
         char *Name               // 
  );

  int  __declspec(dllexport) __stdcall AddRecAdjust(double Sum,char *Text );

  int  __declspec(dllexport) __stdcall  AddPay(
         int PayType,
         double SumCash,
         double SumCashless
  );
  int  __declspec(dllexport) __stdcall CloseReceipt( int flag );

  int  __declspec(dllexport) __stdcall  GetLastDocNum(void) ;

  int  __declspec(dllexport) __stdcall Zreport( void );

  int  __declspec(dllexport) __stdcall Xreport( void );

  int  __declspec(dllexport) __stdcall GetExErrorCode( void );

  int  __declspec(dllexport) __stdcall QueryEcrIdent(
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion
  );
  int  __declspec(dllexport) __stdcall QueryEcrIdentEx(
         char *ModelName,
         char *Manufacturer,
         char *FirmvareVersion,
         char *SN         
  );

  int  __declspec(dllexport) __stdcall QueryEcrDateTime( char  *pdatetime);
  int  __declspec(dllexport) __stdcall SynchronazeDateTime(void);
}

HANDLE         hCOM;               //
DCB            dcb;                //    COM-
COMMTIMEOUTS   sTO;                //

unsigned char  NomIn=0,NomOut=0;       //  /  

unsigned char  password[16];       // ,   Connect()
int            CurrMode;           //  0-. , 1-, -1 - .
int            Operator;           //  
int            EX_Error;           //   


int                DocType;        //  
DocOperationData   DocData[300];   //  
int                opcur;          //   
int LastDocNum;                    //         

///////////////////////////////////////////////////////////////////////////////
//  
///////////////////////////////////////////////////////////////////////////////
int SendKvit(int netno, unsigned char val);
int WaitKvit(int netno, unsigned char* value);
int WaitData(unsigned char *pdata, int maxlen, int *prxkol);
int WaitDataFromKKM(int netno, int maxlen, int *plen, unsigned char *pbuf);
int SendDataToKKM(int netno, int len, unsigned char  *pdata);
int GetStateKKM( int NetNo, int *pmode );
int ExitFromCashMode( void );

bool StrToBcd(
   unsigned char *pbcd,      //   bcd-
   int blen,                 // .  bcd-  
   unsigned char *pstr,      //   
   int slen,                 //  
   int point                 //    
);

void IntToBcd( unsigned char *pbcd, int lenb);
unsigned int  BcdToInt( unsigned char *pbcd, int lenb);
void DoubleToBcd( unsigned char *pbcd, int lenbcd, double val );
double BcdToDouble( unsigned char *pbcd, int lenbcd );
int RecodeErrorKKM( int *err );



BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
    switch( fwdreason )
    {
        case DLL_PROCESS_ATTACH:
        {
           memset( password, '*', 10 );
           CurrMode=-1; DocType=-1; Operator=0;
           EX_Error = 0; opcur=0;
           hCOM=INVALID_HANDLE_VALUE;
           return true;
         }

        case DLL_THREAD_ATTACH:  return false;  //   !


        case DLL_THREAD_DETACH:  break;

        case DLL_PROCESS_DETACH:
        {
          if(hCOM != INVALID_HANDLE_VALUE) {
             CloseHandle( hCOM );
             hCOM = INVALID_HANDLE_VALUE;
          }
          break;
        }
    }
    return true;  // Successful DLL_PROCESS_ATTACH.
}//<<< Eof DllMain() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


void LOG(char*s)
 {
  return;
  FILE *out = fopen("DrvMercFR.log", "a+t");
  if(out)
   {
    fprintf(out,"%d:%s\n",clock(),s);
    fclose(out);
   }
 }
int RecodeErrorKKM( int *err )
{
   int ecode;

   ecode = *err;

   switch( ecode )
   {
      case ENET_DOCOPEN: {
         if( err!=NULL ) *err=0;
         return ERR_REC_OPENED;
      }

      case ENET_BADOPER: {
         if( err!=NULL ) *err=EX_IAE_INVALID_OPER_TYPE;
         return  ERR_ECR_ERROR;
      }

      case ENET_ONLZERO: {
         if( err!=NULL ) *err=0;
         return ERR_BLANKING_NEEDED;
      }

      case ENET_NOTFIND: {
         if( err!=NULL ) *err=0;
         return ERR_VALUE_NOT_DEFINED;
      }

      case ENET_NOTAX: {
         if( err!=NULL ) *err=0;
         return ERR_VALUE_NOT_DEFINED;
      }

      case ENET_DOCOVR: {
         if( err!=NULL ) *err=EX_IAE_TOTAL_OVERFLOW;
         return  ERR_ECR_ERROR;
      }

      case ENET_TIMEOUT: {
         if( err!=NULL ) *err=0;
         return  ERR_NO_RESPONSE;
      }

      case ENET_BADPSW: {
         if( err!=NULL ) *err=0;
         return ERR_PASSWORD_NOT_VALID;
      }

      case ENET_ERDEPTH: {
         if( err!=NULL ) *err=EX_IAE_INVALID_DEPARTMENT;
         return ERR_INVALID_ARG;
      }

      case ENET_NOMONEY: {
         if( err!=NULL ) *err=0;
         return ERR_TO_LITTLE_CASHES;
      }

      default: {
         if( err!=NULL ) *err=0;
         return  ERR_ECR_ERROR;
      }
   }
}


int  GetStateKKM( int NetNo, int *pmode )
{
  int            res,i;
  unsigned char  txbuf[5], rxbuf[64];

  if( hCOM == INVALID_HANDLE_VALUE ) return ENET_NOT_CONN;

  txbuf[0]=2; txbuf[1]=1; txbuf[2]=0;   //  2;  1; =0;
  res = SendDataToKKM( NetNo, 3, &txbuf[0] );
  if( res==ENET_SUCCS ) // ,  
  {
    res=WaitDataFromKKM( NetNo, 256, &i, &rxbuf[0] );
    if( res==ENET_SUCCS )
    {
      if( rxbuf[2]==0 || rxbuf[2]==ENET_DOCOPEN )
      {
         *pmode = (int) rxbuf[3];
         if( rxbuf[2]==ENET_DOCOPEN ) { *pmode=1; }  // ..  
         return  ENET_SUCCS;
      }
      else return ENET_FORMAT; //      
    } return res;
  }
  else  {return ENET_TX_ERR;}  //   

}//<<< EOF  GetStateKKM()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int ExitFromCashMode( void )
//////////////////////////////////////////////////////////////////////////////
//     .     - 
//
//   (  ):
//    SUCCESS         -     :)
//    ERR_NO_RESPONSE -   
//    ERR_INTERNAL    -   
//
//////////////////////////////////////////////////////////////////////////////
{
 int           res,i,kol;
 unsigned char txbuf[32], rxbuf[256], ch;

 if( hCOM == INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

 CurrMode = -1;  // -  
 kol = 5;

 while( kol>0 )
 {
     txbuf[0]=2; txbuf[1]=2;  memset( &txbuf[2], 0, 17 );
     LOG(">>>>>ExitFromCashMode SendDataToKKM begin");
     res = SendDataToKKM( 1, 19, &txbuf[0] );
     LOG(">>>>>ExitFromCashMode SendDataToKKM end");     
     if( res==ENET_SUCCS ) // ,  
     {

        res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
        if( res==ENET_SUCCS )
        {
          if( rxbuf[2]==0 )
          {
             CurrMode = 0;
             LOG(">>>>>ExitFromCashMode SUCCESS");
             return SUCCESS;
          }
          else //---    
          {
            LOG(">>>>>ExitFromCashMode ECR ERROR");
             if( rxbuf[2]==ENET_DOCOPEN )
             {
                txbuf[0]=2; txbuf[1]=6; txbuf[3]=0;
                res = SendDataToKKM( 1, 3, &txbuf[0] );
                if( res==ENET_SUCCS )
                {
                   WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
//                   Sleep(5);
                   kol--;
                }
                else kol--;
             }
             else return ERR_ECR_ERROR;
          }
        }//---    

        else
        {
           LOG(">>>>>ExitFromCashMode ERROR WaitDataFromKKM");
           EX_Error = res;
           return RecodeErrorKKM( &EX_Error );
        }
     }
     else
     {
       LOG(">>>>>ExitFromCashMode ERROR SEND");

        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );
     }
 }//eof while( !fStop )

 return ERR_ECR_ERROR;
}


int SendDataToKKM(
/////////////////////////////////////////////////////////////////////////////
//
//         
//
/////////////////////////////////////////////////////////////////////////////
   int            netno,      //   
   int            len,        //   
   unsigned char  *pdata)     //     
{
  unsigned char  txbuf[600], nom, crc, flc;
  unsigned char  *dest;
  unsigned long  txkol,count,i;
  int            res;
  bool           fSucs;
  DWORD          Errors;

  nom = ((unsigned char)(netno/10))*16;
  nom = nom + ((unsigned char)(netno-nom*10));
  txbuf[0]= 0x7F;
  txbuf[1]= 0x02;
  txbuf[2]= nom;
  txbuf[3]= 0x80 | (NomOut & 0x07);
  txbuf[4]= 0 -( txbuf[2] + txbuf[3] );

  //---     ( 0x7F  DLE)
  txbuf[5] = 0;                                  // SYNC 
  dest = &txbuf[6];                              //   - 

  txkol=0;  count = 0; crc = 0;
  while( count<len )
  {
     nom = *(pdata+count);
     *(dest+txkol) = nom;
     crc = crc + nom;
     count++; txkol++;
     if( nom == 0x7F ) { *(dest+txkol) = DLE; txkol++; }
  }

  *(dest+txkol)= 0x7F; txkol++;  // 
  *(dest+txkol)= 0x03; txkol++;  // ETX
  *(dest+txkol)= 0 - crc;        //    

  txkol = txkol + 1 + 1 + 5;     //

  //---  ,  

  count = 0; fSucs=false;
  while( (!fSucs)&&(count<6) )
  {
     //flc = 0x80 | (NomOut & 0x07);
     //SendKvit( netno, flc );
     LOG(">>>>>-------------------SendDataToKKM WriteFile begin");
     fSucs = WriteFile( hCOM, &txbuf[0], txkol, &txkol, NULL );
     LOG(">>>>>-------------------SendDataToKKM WriteFile end");
     if( fSucs ) {

        fSucs = false;
        LOG(">>>>>-------------------SendDataToKKM WaitKvit begin");
        res = WaitKvit(netno,&flc);
        LOG(">>>>>-------------------SendDataToKKM WaitKvit end");        
        if( res == ENET_SUCCS )
        {
        LOG(">>>>>-------------------SendDataToKKM WaitKvit ENET_SUCCS");
          flc = flc & 0xDF;  //   
          switch( flc )
          {
            case ACK: { LOG("--ACK");NomOut++; return ENET_SUCCS; }

            case NAK: {LOG("--NAK"); count++; Sleep(20); break; }
            case BUSY:{LOG("--BUSY");Sleep(50); break; }
            case SYN: {
               LOG("--SYN");
               NomIn=0; NomOut=0; Sleep(5);count++;// if(count)count--;
               break;
            }
            default:  {LOG("--????"); count++; }
          }//--- end switch( res )
        }
        else
        {
        LOG(">>>>>-------------------SendDataToKKM WaitKvit ERROR ENET_SUCCS");
         count++;
        }
     }
     else count++;

  }//--- end while

  if( res == ENET_TIMEOUT) { return res; } else return ENET_TX_ERR;

}//<<< EOF SendDataToKKM >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int WaitDataFromKKM(int netno, int maxlen, int *plen, unsigned char *pbuf )
{
  int i,j,res;
  unsigned char flc;

  i=0;  j=0;
  do
  {//--- 10    ----
     do
     {//---    ()
        res = WaitKvit( netno, &flc );
        if( res==ENET_SUCCS && ((flc & 0xC0)!=0x80 ))
        {
           switch( flc )
           {
             case SYN:  { NomIn=0; NomOut=0; return ENET_FORMAT;LOG("SYN"); }
             case BUSY: { j=0; break; LOG("BUSY");}
             default: {return ENET_FORMAT;}
           }
        }
        else {j++;LOG(" ");}
     } while( j<10 && res!=ENET_SUCCS );

     if( res != ENET_SUCCS ) return ENET_TIMEOUT; //     
     if( res==ENET_SUCCS && ((flc & 0xC0)==0x80) )
     {
       res = WaitData( pbuf, maxlen, plen);
       switch( res )
       {                                            /**************/
          case ENET_SUCCS: { SendKvit( netno, ACK );Sleep(20); return res; }

          case ENET_BADCRC: { SendKvit( netno, NAK); i++; break; }

          default: { return res; }
       }
     } else i++;

  } while( i<5 && res!=ENET_SUCCS);

  return ENET_RX_ERR;

}//<<< End of WaitDataFromKKM() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int SendKvit(int netno, unsigned char val)
/////////////////////////////////////////////////////////////////////////////
//
//    val     netno
//
/////////////////////////////////////////////////////////////////////////////
{
  unsigned char  txbuf[8],nom;
  unsigned long  len;
  bool           fSucs;
  DWORD          Errors;

  if( (netno>0)&&(netno<99))
  {
     nom = ((unsigned char)(netno/10))*16;
     nom = nom + ((unsigned char)(netno-nom*10));
     txbuf[0]= 0x7F;
     txbuf[1]= 0x02;
     txbuf[2]= nom;
     txbuf[3]= val;
     txbuf[4]= 0-( nom + val );

     len = 5;
     fSucs = WriteFile( hCOM, &txbuf[0], len, &len, NULL );

     if( fSucs ) { return ENET_SUCCS; }
       else {
         Errors = CE_BREAK|CE_FRAME|CE_IOE|CE_MODE|CE_OVERRUN|CE_RXOVER|CE_RXPARITY|CE_TXFULL;
         ClearCommError(hCOM, &Errors, NULL);
         return ENET_TX_ERR;
       }
  }
  else return ENET_BADNOM;

}//<<< End of SendKvit() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int WaitKvit(int netno, unsigned char* value)
/////////////////////////////////////////////////////////////////////////////
//
//  / .   ,   0
//     value   .  
//     :
//
//    ENET_TIMEOUT - - 
//    ENET_BADCRC  -   
//    ENET_FORMAT  -      . 
//
/////////////////////////////////////////////////////////////////////////////
{
  unsigned char  rxbuf[16],nom,crc;
  unsigned long  len;
  BOOL           fSucs;

  nom = (unsigned char)netno;
  len = 5;
  fSucs = ReadFile( hCOM, &rxbuf[0], len, &len, NULL );

  if( fSucs && (len==5) )
  {
    crc = rxbuf[2]+rxbuf[3]+rxbuf[4];
    if( crc==0 )
    {
      if( (rxbuf[0]==0x7F)&&(rxbuf[1]==0x02)&&(rxbuf[2]==nom) )
      {
         *value = rxbuf[3];
         return ENET_SUCCS;
      }
      else {LOG("ERROR WaitKvit ENET_FORMAT"); return ENET_FORMAT;}
    }
    else {LOG("ERROR WaitKvit ENET_BADCRC");return ENET_BADCRC;}
  }
  else  {LOG("ERROR WaitKvit ENET_TIMEOUT");return ENET_TIMEOUT;}

}//<<< End of WaitKvit() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int  WaitData(unsigned char *pdata, int maxlen, int *prxkol)
/////////////////////////////////////////////////////////////////////////////
//
//       pdata   maxlen.  :
//
//    NET_ERR_TIMEOUT   - -   
//    NET_ERR_OVERSIZE  -  .   
//    NET_ERR_FORMAT    -   
//    NET_ERR_BADCRC    -   
//
////////////////////////////////////////////////////////////////////////////
{
   unsigned char  ch, crc;
   unsigned long  kolb;
   int            i;
   BOOL           fSucs, fMarker, fEndData;

   //  -
   kolb = 1;
   fSucs = ReadFile( hCOM, &ch, kolb, &kolb, NULL );
   if( !fSucs || ( kolb != 1 ))  return ENET_TIMEOUT;

   crc = 0;  i = 0;  fMarker = false;  fEndData = false;

   while( (i < maxlen) && (fEndData == false) )
   { /* -1- */

     kolb = 1;
     fSucs = ReadFile( hCOM, &ch, kolb, &kolb, NULL );
     if( (fSucs==false) || (kolb != 1) ) return ENET_TIMEOUT;

     if( ((fMarker == true)&&(ch == 0x03)) != true ) //---    ;)
     {/* -2- */

       if( (fMarker==true) && (ch==0x10) ) //---    Marker:Dle
       {
         *(pdata+i) = 0x7F;
         crc = crc + 0x7F;
         i++;
         fMarker = false;
       }
       else
       {
         if( (fMarker==true)&&(ch != 0x10) )
         {
            return ENET_FORMAT;
         }
         else
         {
            if( (fMarker==false)&&(ch==0x7F) )
            {
              fMarker=true;
            }
            else
            {
              if((fMarker==false)&&(ch!=0x7F))
              {
                 *(pdata+i) = ch;
                 crc = crc + ch;
                 i++;
              };
            };
         };
       };
     }
     else  fEndData = true;       //--- Marker:Etx - 
   };/* -1- *      */


   if( fEndData == false )  return ENET_OVERSIZE;

   //   CRC
   kolb = 1;
   fSucs = ReadFile( hCOM, &ch, kolb, &kolb, NULL );
   if( !fSucs || ( kolb != 1 ))  return ENET_TIMEOUT;

   crc = crc + ch;
   if( crc != 0 )
   {
      *prxkol = 0;
      return ENET_BADCRC;
   }
   else
   {
      *prxkol = i;
       return ENET_SUCCS;
   }
}//<<< End of WaitData() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


bool StrToBcd(
   unsigned char *pbcd,      //   bcd-
   int blen,                 // .  bcd-  
   unsigned char *pstr,      //   
   int slen,                 //  
   int point                 //    
)
{
  int i,j,dec;
  bool fPoint;
  unsigned char *pch, ch, buf[32];

  memset(pbcd,0,blen);       //---  

  i=0; j=0; dec=0; fPoint=false;
  do
  {//---   ( ),      
     ch=*(pstr+i);
     if( ch>='0' && ch<='9' )
     {
        buf[j]=ch;   //  
        i++; j++;
        if( fPoint ) dec++;
     }
     else
     {
        if( ch=='.' || ch==',' )
        {
          i++;
          if( !fPoint ) { fPoint=true; } else return false;
        }
        else
          if( ch!='\0' ) return false;
     };
  } while( i<slen && ch!='\0' && (dec<=point) && (j<(32-(point-dec))) );

  if( !j ) return true;

  while( dec<point ) { buf[j]='0'; j++; dec++; }

  if(dec>point) j--;  // 1 .     .

  i=0; pch=pbcd;

  while( j>0 && i<blen*2 )
  {
     ch=buf[j-1];

     if( (i&1) == 0 )
     {
       *pch = ch-0x30;
     }
     if( (i&1) == 1 )
     {
       *pch = *pch | (ch-0x30)*16;
        pch++;
     }
     j--; i++;
  };
  return true;
}//<<< EOF StrToBcd()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


void IntToBcd( unsigned char *pbcd, int lenb, int val)
//////////////////////////////////////////////////////////////////////////////
//
//    double (  !)  BCD
//
//////////////////////////////////////////////////////////////////////////////
{
   int i,x,res;
   unsigned char *pch,dgt;

   i=0;  x=val; pch=pbcd;
   while( i < lenb*2 )
   {
      res = x/10;
      dgt = (unsigned char)(x - res*10);
      x=res;

      if( (i&1) == 0 )
      {
         *pch=dgt;
      }
      else
      {
         dgt = dgt<<4;
         dgt = (*pch) | dgt;  *pch=dgt;
         pch++;
      }
      i++;
   }

}//<<< EOF IntToBcd() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



unsigned int  BcdToInt( unsigned char *pbcd, int lenb)
///////////////////////////////////////////////////////////////////////////////
//
//     BCD-  unsigned int.
//     4 294 967 295.
//   BCD-   ,   0.
//
///////////////////////////////////////////////////////////////////////////////
{
   int res,i,pos,mul;
   unsigned char ch;

   res=0;     // 
   i=0;       //  
   pos=0;     //  
   mul=1;     // 

   while( pos<lenb && pos<5 )
   {
      if( (i&1) == 0 )
      {
         ch=*(pbcd+pos); ch=ch&0x0F;
         res= res + ch * mul;
      }
      else
      {
         ch=*(pbcd+pos); ch=ch&0xF0; ch=ch >> 4;

         if( i<9 || ( i==9 && ch<4 ))
         {
            res = res + ch * mul;
         }
         else
         {
            if( ch==4 && res <= 294967295 )
            {
               res= res + ch * mul;
               return res;
            }
            else return 0;
         }
         pos++;
      }
      i++;  mul=mul*10;
   }
   return res;
}//<<< EOF BcdToInt() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


void DoubleToBcd( unsigned char *pbcd, int lenbcd, double val )
//////////////////////////////////////////////////////////////////////////////
//
//    double (  !)  BCD
//
//////////////////////////////////////////////////////////////////////////////
{
   int i;
   double  x,res;
   unsigned char *pch,dgt;

/**/   double Corrector;
/**/   if(val>0)Corrector=0.001; else Corrector = -0.001;
/**/   val = val + Corrector;


   x = val - fmod(val,1);      //     
   i=0;  pch=pbcd;
   while( i < lenbcd*2 )
   {
      res = fmod(x,10);  x = x/10;
/**/      x = x +Corrector;
/**/      x = x - fmod(x,1);
      dgt = (unsigned char) res;

      if( (i&1) == 0 )
      {
         *pch=dgt;
      }
      else
      {
          dgt = dgt<<4;
          dgt = (*pch) | dgt;  *pch=dgt;
          pch++;
      }

      i++;
   }
}//<<< EOF DoubleToBcd() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


double BcdToDouble( unsigned char *pbcd, int lenbcd )
{
  unsigned char ch;
  double res, mul;
  int    i,pos;

  res = 0; pos=0; mul=1;
  while( pos<lenbcd )
  {
     ch = *(pbcd+pos);
     if( (i&1) == 0 ){ ch=ch & 0x0F; } else { ch=ch & 0xF0; ch=ch>>4; pos++; }
     res = res + ch*mul;
     i++;
  }
  return res;
}//<<< EOF BcdToDouble() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int  __stdcall Connect(
///////////////////////////////////////////////////////////////////////////////
//          .
//    :
//     SUCCESS -   .
//     ERR_INVALID_ARG -         
//                             
//     ERR_NO_RESPONSE -      
////////////////////////////////////////////////////////////////////////////////
    unsigned char  PortNum,    //  
    unsigned short BaudRate,   //  
    unsigned short Timeout,    // - ()
    char           *psw        // 
)
{
  LOG(">>Connect BEGIN");
  char  portname[8],txbuf[16];
  int   result,ival;
  DWORD val;
  LastDocNum =-1;
    EX_Error = 0;

    if( Timeout < 100 )
    {
       EX_Error = EX_IAE_INVALID_TIMEOUT;
       return ERR_INVALID_ARG;
    }

    if( hCOM!=INVALID_HANDLE_VALUE)
    {
       CloseHandle(hCOM);
       hCOM = INVALID_HANDLE_VALUE;
    }

    //========================================================================
    //   
    //========================================================================

    sprintf(portname,"COM%d", PortNum );    //   

    hCOM = CreateFile(
             portname,                      //
             GENERIC_READ|GENERIC_WRITE,    //   
             0,                             //  COM-
             NULL,                          //
             OPEN_EXISTING,                 //
             FILE_ATTRIBUTE_NORMAL,         //
             NULL                           //
    );
  LOG(">>Connect OPEN Port");
    if( hCOM != INVALID_HANDLE_VALUE )
    {//*1*-----------------------------------------------------------------
     //    
     //--------------------------------------------------------------------
       if( GetCommState(hCOM,&dcb) )
       {//*2*
          switch( BaudRate )
          {
             case  4800: {
                dcb.BaudRate=CBR_4800;
                break;
             }
             case  9600: {
                dcb.BaudRate=CBR_9600;
                break;
             }
             case  19200: {
                dcb.BaudRate=CBR_19200;
                break;
             }
             case  38400: {
                dcb.BaudRate=CBR_38400;
                break;
             }
             case  57600: {
                dcb.BaudRate=CBR_57600;
                break;
             }
             case  115200: {
                dcb.BaudRate=CBR_115200;
                break;
             }
             default:
             {
                EX_Error = EX_IAE_INVALID_BAUD_RATE;
                return ERR_INVALID_ARG;
             }   
          }// eof switch (BaudRate)

          dcb.ByteSize = 8;            //   8 
          dcb.fBinary = true;          //    

          dcb.fNull = false;           //

          dcb.fOutxCtsFlow = false;    // disable TS output flow control
          dcb.fOutxDsrFlow = false;    // disable DSR output flow control
          dcb.fErrorChar = false;      // disable error replacement

          dcb.fAbortOnError = true;    // abort reads/writes on error

          dcb.fDtrControl = DTR_CONTROL_DISABLE;  // DTR flow control disable
          dcb.fRtsControl = RTS_CONTROL_DISABLE;  // RTS flow control
          dcb.fDsrSensitivity = false;            // DSR sensitivity disable

          dcb.fOutX = false;                     // disable XON/XOFF out flow control
          dcb.fInX = false;                      // disable XON/XOFF in flow control

          dcb.XonLim = 256;                      // transmit XON threshold
          dcb.XoffLim = 2048;                    // transmit XOFF threshold

          dcb.XonChar = 0x7F;                    // Tx and Rx XON character
          dcb.XoffChar = 0x7F;                   // Tx and Rx XOFF character

          dcb.EvtChar = 0x02;                    // received event character
          dcb.ErrorChar = 0x00;                  // error replacement character
          dcb.EofChar = 0x03;                    // end of input character

          dcb.fTXContinueOnXoff = false;         // XOFF continues Tx (????)

          if( !SetCommState(hCOM, &dcb) )
          {
             CloseHandle(hCOM);
             hCOM = INVALID_HANDLE_VALUE;
             return ERR_INVALID_ARG;
          }
       }
       else
       {
          CloseHandle(hCOM);
          hCOM = INVALID_HANDLE_VALUE;
          return ERR_INVALID_ARG;
       }//*2*

    }//*1*

    else
    {
      EX_Error = EX_IAE_INVALID_PORT_NUM;
      return ERR_INVALID_ARG;
    };


    //---------------------------------------------------------------------
    //   -
    //---------------------------------------------------------------------

    if( GetCommTimeouts(hCOM, &sTO) )
    {
      sTO.ReadTotalTimeoutConstant = Timeout;
      sTO.ReadTotalTimeoutMultiplier = 3*2;
      sTO.ReadIntervalTimeout = 3*2;
      sTO.WriteTotalTimeoutConstant = 100*2;
      sTO.WriteTotalTimeoutMultiplier = 5*2;

      if( !SetCommTimeouts( hCOM, &sTO ) ) {
        CloseHandle( hCOM );
        hCOM = INVALID_HANDLE_VALUE;
        EX_Error = EX_IAE_INVALID_PORT_NUM;
        return ERR_INVALID_ARG;
      }
    }
    else
    {
      CloseHandle(hCOM);
      hCOM = INVALID_HANDLE_VALUE;
      EX_Error = EX_IAE_INVALID_PORT_NUM;
      return ERR_INVALID_ARG;
    }

    PurgeComm(hCOM,PURGE_TXABORT|PURGE_RXABORT|PURGE_TXCLEAR|PURGE_RXCLEAR);
    ClearCommError(hCOM,&val,NULL);
    LOG(">>Connect Port configured");
    //========================================================================
    //    .  ,   ,  
    //     
    //========================================================================
    result=GetStateKKM( 1, &ival );
    LOG(">>Connect GetStateKKM end");
//    Sleep(50);
    if( result==ENET_SUCCS )
    {
       switch( ival )
       {
         case 0: //   
         {
           CurrMode=0;
           memset( password, '0', 16 );
           #ifdef password4
           strncpy( &password[2], psw, 4 );
           #else
           strncpy( &password[0], psw, 6 );
           #endif
           EX_Error=0;
           return SUCCESS;
         }
         case 1: //     
         {
           LOG(">>Connect ExitFromCashMode begin");
           result = ExitFromCashMode();
           LOG(">>Connect ExitFromCashMode end");
           if( result==SUCCESS )
           {
              CurrMode=0;
              memset( password, '0', 16 );
              #ifdef password4
              strncpy( &password[2], psw, 4 );
              #else
              strncpy( &password[0], psw, 6 );
              #endif
              EX_Error=0;
              return SUCCESS;
           }
           else
           {
              CurrMode=-1;
              memset( password, '*', 16 );
              return result;
           }
         }
       }
    }
    else //      
    {
      EX_Error = result;
      return RecodeErrorKKM( &EX_Error );
    }
}//<<< EOF Connect() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

int __stdcall Disconnect( void )
{
   if( hCOM!=INVALID_HANDLE_VALUE ) CloseHandle( hCOM );
   hCOM = INVALID_HANDLE_VALUE;

   CurrMode= -1;
   memset( password,'*',16 );

   return SUCCESS;
}//<<< EOF Disconnect() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

int  __stdcall SendText(char *Text )
//////////////////////////////////////////////////////////////////////////////
//
//    
//
//////////////////////////////////////////////////////////////////////////////
{
 int res, kol, i;
 unsigned char txbuf[64], rxbuf[256];
 EX_Error = 0;
 if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;
 memset( &txbuf[0], 0, 34 );
 txbuf[0]=2; txbuf[1]=16;
 strncpy(&txbuf[2],Text,32);
 res = SendDataToKKM( 1, 34, &txbuf[0] );
 if( res==ENET_SUCCS ) // ,  
   {
      res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
      if( res==ENET_SUCCS )
      {

        if( rxbuf[2]==0 )
        {
           return SUCCESS;
        }
        else
        {
           EX_Error = rxbuf[2];
           return RecodeErrorKKM( &EX_Error );
        }

      }//---    
      else
      {
         EX_Error = res;
         return RecodeErrorKKM ( &EX_Error );
      }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error);   //   
   }
 return ERR_ECR_ERROR;            //   
}


int __stdcall RegisterOper( int OperNum, char *OperName )
//////////////////////////////////////////////////////////////////////////////
//     .
//           , 
//    Connect.   OperNum  OperName .
//////////////////////////////////////////////////////////////////////////////
{
 int res, kol=3, i;
 unsigned char txbuf[32], rxbuf[256];

 EX_Error = 0;
 if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

 while( (kol--)>0 )
 {
     txbuf[0]=2; txbuf[1]=2;  txbuf[2]=1;
     memset( &txbuf[3], '0', 16 );
     memcpy( &txbuf[3], password, 6 );

     res = SendDataToKKM( 1, 19, &txbuf[0] );
     if( res==ENET_SUCCS ) // ,  
     {

        res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
        if( res==ENET_SUCCS )
        {

          if( rxbuf[2]==0 )
          {
             Operator = OperNum;
             CurrMode = 1;
             Sleep(300);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             RecodeErrorKKM( &EX_Error );
          }

        }//---    

        else
        {

          EX_Error = res;
          if(kol==1)return RecodeErrorKKM ( &EX_Error );
        }
     }
     else
     {
        
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error);   //   
     }

 }//eof while( !fStop )

 return ERR_ECR_ERROR;            //   
}


int __stdcall GetCurrOper(int *OperNum)
{
   if( hCOM==INVALID_HANDLE_VALUE )
   {
      *OperNum = -1;
      return ERR_CONN_CLOSED;
   }

   else { *OperNum=Operator; return SUCCESS; }
}//<<< EOF  GetCurrOper()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int __stdcall GetTaxRate(
///////////////////////////////////////////////////////////////////////////////
// :
//    C     .
// :
//    TaxIndex -   .
//    TaxVal   -   ,     .
//                      .
//    Name     -   .
//
//   :
//    SUCCESS          -  
//    ERR_CONN_CLOSED  -     
//    ERR_NO_RESPONSE  -   
///////////////////////////////////////////////////////////////////////////////
       int  TaxIndex,
       int  *TaxVal,
       char *Name
)
{
 int res, i;
 unsigned char txbuf[32], rxbuf[256];

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;
  if( TaxIndex<1 || TaxIndex > 5 )
  {
     EX_Error = EX_IAE_INVALID_TAX_INDEX;
     return ERR_INVALID_ARG;
  }

  txbuf[0]=2; txbuf[1]=10;  txbuf[2]= (unsigned char)TaxIndex;

  res = SendDataToKKM( 1, 3, &txbuf[0] );
  if( res==ENET_SUCCS ) // ,  
  {
     res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
     if( res==ENET_SUCCS )
     {
       if( rxbuf[2]==0 )
       {
           if( rxbuf[3]== 0xAA)
           {
             *TaxVal=BcdToInt(&rxbuf[5],2);   //  

             i=0;                             //
             while( i<12 && rxbuf[7+i]!=0x0 ) //
             {                                //  
               *(Name+i)=rxbuf[7+i]; i++;     //
             }                                //
             *(Name+i)=0x0;                   //
             return SUCCESS;
           }
           else
           {
              *TaxVal=0; *Name=0x0;
              return ERR_VALUE_NOT_DEFINED;
           }
       }
       else
       {
          EX_Error = rxbuf[2];
          return RecodeErrorKKM( &EX_Error );
       }
     }//---    

     else
     {
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );
     }
  }
  else
  {
    EX_Error = res;
    return RecodeErrorKKM( &EX_Error);        //   
  }
}//<<< EOF  GetTaxRate() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int __stdcall GetTaxNum(int *TaxNum)
///////////////////////////////////////////////////////////////////////////////
//  :
//	    
//              .
//  :
//            TaxNum -   ,    
//                     .
//   :
//            SUCCESS  -  
//            ERR_CONN_CLOSED  -     
//            ERR_NO_RESPONSE   -   
///////////////////////////////////////////////////////////////////////////////
{
 int res,i;
 unsigned char txbuf[32], rxbuf[256];

  EX_Error = 0;
  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  txbuf[0]=2; txbuf[1]=11;  txbuf[2]= 0;

  res = SendDataToKKM( 1, 3, &txbuf[0] );
  if( res==ENET_SUCCS ) // ,  
  {
     res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
     if( res==ENET_SUCCS )
     {
       if( rxbuf[2]==0 )
       {
           *TaxNum = rxbuf[3];
           return SUCCESS;
       }
       else
       {
          EX_Error = rxbuf[2];
          return RecodeErrorKKM( &EX_Error );
       }
     }//---    

     else
     {
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );  //   
     }
  }
  else
  {
     EX_Error = res;
     return RecodeErrorKKM( &EX_Error );  //   
  }
}//<<< EOF  GetTaxNum()  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int  __stdcall OpenReceipt(int OperType)
///////////////////////////////////////////////////////////////////////////////
// :
//	     .
//  :
//         OperType
//          :
//         0 - ;
//         1 -  ;
//         2 -  ;
//         3 -  ;
//   :
//    SUCCESS -  
//    ERR_CONN_CLOSED -     
//    ERR_NO_RESPONSE -   
//    ERR_REC_OPENED  -   
//    ERR_INVALID_ARG  -   .
//    ERR_ECR_ERROR  -  
///////////////////////////////////////////////////////////////////////////////
{
    EX_Error = 0;
    if( OperType<0 || OperType>3)
    {
       EX_Error = EX_IAE_INVALID_OPER_TYPE;
       return ERR_INVALID_ARG;
    }

    DocType = OperType;  opcur = 0;
    return SUCCESS;
}//<<< EOF  OpenReceipt() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int __stdcall  AddRecEntry(
///////////////////////////////////////////////////////////////////////////////
//  :
//	    .
//
//   Depart, Code, Quantity, QuantityPrec,
//  TaxGroup  Name     /  .
//
//   :
//      SUCCESS          -  
//      ERR_REC_NOOPEN   -   
//	ERR_CONN_CLOSED  -     
//	ERR_NO_RESPONSE  -   
//	ERR_DOC_OVERFLOW -     ;
//	ERR_INVALID_ARG  -   .
//	ERR_ECR_ERROR    -  .
//
// ******************     *******************************
//
// 3	OpCode	1	BIN	  (A3H,A5H,ADH,AEH)
// 4	OpNum	1	BCD	 .    +1
// 5	Rezerved	3	BIN	, 
// 8	ItemName	32	ASCIIZ	 ***
// 40	ItemPrice	5	BCD	  
// 45	TaxesCode	1	BIN	  
// 46	DepthNum	1	BIN	  ()
// 47	OpFlags	1	BIN	 ( , )
// 48	Kolvo	5	BCD	
// 53	EdName	5	ASCIIZ	  ( , )
//		58
///////////////////////////////////////////////////////////////////////////////

      double Price,            //  /
      int Quantity,            // 
      int  QuantityPrec,       //  
      double Sum,              //  (   )
      int Depart,              // 
      int TaxIndex,            //  
      int Code,                // 
      char *Name               // 
)
{
  unsigned char  ch;
  double         price;
  int            i,kolvo,res;

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE) return ERR_CONN_CLOSED;
  if( DocType < 0 || DocType>3 )
  {
     EX_Error = EX_IAE_INVALID_OPER_TYPE;
     return ERR_REC_NOOPEN;
  }

  if( DocType < 2 )//----   
  {
    if( Price <= 0 )
    {
       EX_Error = EX_IAE_INVALID_ENTRY_SUM;
       return ERR_INVALID_ARG;
    }
    if( Quantity<=0 || QuantityPrec>3 || QuantityPrec<0)
    {
       EX_Error = EX_IAE_INVALID_QUANTITY;
       return ERR_INVALID_ARG;
    }
    if( Depart<1 || Depart>16)
    {
       EX_Error = EX_IAE_INVALID_DEPARTMENT;
       return ERR_INVALID_ARG;
    }
    if( TaxIndex <0 || TaxIndex>5 )
    {
       EX_Error =   EX_IAE_INVALID_TAX_INDEX;
       return ERR_INVALID_ARG;
    }

    price = Price*100;       //    
    if( price> 9999999999 )
    {
       EX_Error = EX_IAE_INVALID_ENTRY_SUM;
       return ERR_INVALID_ARG;
    }

    switch( QuantityPrec )
    {
       case 0: { kolvo = Quantity*1000; break; }
       case 1: { kolvo = Quantity*100;  break; }
       case 2: { kolvo = Quantity*10;   break; }
       case 3: { kolvo = Quantity;      break; }
       default:
       {
         EX_Error = EX_IAE_INVALID_QUAN_PREC;
         return ERR_INVALID_ARG;
       }
    }

    if( kolvo>9999999999)
    {
       EX_Error = EX_IAE_INVALID_QUANTITY;
       return ERR_INVALID_ARG;
    }

    //=========================================================================
    //     
    //=========================================================================
    if(Code==2)LOG("AddRecEntry Code==2");else LOG("AddRecEntry Code!=2");
    IntToBcd( &DocData[opcur].plu[0],3, Code);           //  /
    if(DocData[opcur].plu[0]!=0||DocData[opcur].plu[1]!=0||DocData[opcur].plu[2]!=0)
      LOG("AddRecEntry plu!=0");else LOG("AddRecEntry plu==0");
    DoubleToBcd( &DocData[opcur].summa[0], 5, price );   // 
    DocData[opcur].tax = (unsigned char) TaxIndex;       //   
    DocData[opcur].depth = (unsigned char) Depart;       //  
    IntToBcd( &DocData[opcur].kolvo[0], 5, kolvo );      // 

    i=0; ch= *(Name+i);                      //
    while( i<32 && ch!=0x0 )                 //  
    {                                        //
       ch = *(Name+i);                       //
       DocData[opcur].tovname[i]=ch;         //
       i++;                                  //
    }                                        //
    if(i<32) DocData[opcur].tovname[i]='\0'; //

    if( DocType==0 )
    {
       DocData[opcur].optype=0;             // /
       DocData[opcur].uidop= 0xA3;          //
    }
    else
    {
       DocData[opcur].optype=1;            //  
       DocData[opcur].uidop=0xAD;          //
    }
    DocData[opcur].opnum = opcur;  opcur++;
    return SUCCESS;
  }
  else //------   
  {
     price = Sum*100;                      //   
     if( price<=0 || price>9999999999 )
     {
       EX_Error = EX_IAE_INVALID_ENTRY_SUM;
       return ERR_INVALID_ARG;
     }

     DoubleToBcd( &DocData[opcur].summa[0], 5, price );
     DocData[opcur].optype=DocType;
     DocData[opcur].opnum = opcur;  opcur++;
     return SUCCESS;
  }
}//<<< EOF  AddRecRntry() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



int __stdcall AddRecAdjust(double Sum, char *Text )
///////////////////////////////////////////////////////////////////////////////
//
//  :
//           /  .
//  :
//        Sum -  /
//        Text -  /
//   :
//        SUCCESS -  
//        ERR_REC_NOOPEN  -   
//        ERR_CONN_CLOSED  -     
//        ERR_NO_RESPONSE  -   
//        ERR_DOC_OVERFLOW -     ;
//        ERR_INVALID_ARG  -   .
//        ERR_ECR_ERROR -  .
//
// *********************     *******************************
//  0	VectorNom	1	BIN	2 -  
//  1	FuncNom	        1	BIN	5 -  
//  2	OpCode	        1	BIN	  (C4H,C5H)
//  3	OpNum	        1	BIN	 .    +1
//  4	Summa	        7	BCD	 /
///////////////////////////////////////////////////////////////////////////////
{
 int           res,i;
 bool          fDisc;
 double        summa;

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  if( DocType != 0 )
  {
      EX_Error = EX_IAE_INVALID_ENTRY_TYPE;
      return ERR_INVALID_ARG;
  }

  if( Sum < 0 ){fDisc=true; summa = -1*Sum;} else {fDisc=false; summa = Sum;}

  summa=summa*100;

  if( summa>9999999999)
  {
     EX_Error = EX_IAE_INVALID_ADJUSTMENT;
     return ERR_INVALID_ARG;
  }

  if( fDisc )
  {
     DocData[opcur].optype = 10;
     DocData[opcur].uidop=0xC4;
     LOG("AddRecAdjust 0xC4");
  }
  else
  {
     DocData[opcur].optype = 11;
     DocData[opcur].uidop=0xC5;
     LOG("AddRecAdjust 0xC5");     
  }

  DoubleToBcd( &DocData[opcur].summa[0], 7, summa );
  DocData[opcur].opnum = opcur; opcur++;

  return SUCCESS;
}//<<< EOF  AddRecAdjust() >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int __stdcall  AddPay( int PayType, double SumCash, double SumCashless )
///////////////////////////////////////////////////////////////////////////////
//  :
//	      .   
//         ,    
//
//  :
//     PayType -  
//       0 - ;
//       1 - ;
//       2 -  ;   (   )
//       3 -  + ; (   )
//       4 -  +  . (   )
//
//     SumCash     -   .    
//                    .
//     SumCashless -     . 
//                       .
//
//   :
//    SUCCESS -  
//    ERR_REC_NOOPEN -   
//    ERR_CONN_CLOSED -     
//    ERR_NO_RESPONSE  -   
//    ERR_DOC_OVERFLOW  -     ;
//    ERR_INVALID_ARG  -   .
//    ERR_ECR_ERROR  -  
//
///////////////////////////////////////////////////////////////////////////////
{
  double summa;

  EX_Error = 0;
  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  if( DocType != 0 )
  {
    EX_Error = EX_IAE_INVALID_ENTRY_TYPE;
    return ERR_INVALID_ARG;
  }

  if( PayType<0 || PayType>2 )
  {
    EX_Error = EX_IAE_UNSUPPORTED_PAY_TYPE;
    return ERR_INVALID_ARG;
  }

  if( PayType == 0 )
  {
     summa = SumCash*100;
     DocData[opcur].uidop = 0;
  }
  else
  {
     summa = SumCashless*100;
     DocData[opcur].uidop = 1;
  }

  DocData[opcur].optype = 12;
  DoubleToBcd( &DocData[opcur].summa[0], 7, summa );
  DocData[opcur].opnum = opcur; opcur++;
  return SUCCESS;
}


int __stdcall CloseReceipt( int flag )
//////////////////////////////////////////////////////////////////////////////
// :
//            .
// :
//     flag:
//     0 -    ( ).
//     1 -      .
//  :
//           SUCCESS           -  ;
//           ERR_REC_NOOPEN    -   ;
//           ERR_CONN_CLOSED   -     ;
//           ERR_NO_RESPONSE   -   ;
//           ERR_DOC_OVERFLOW  -     ;
//           ERR_INVALID_ARG   -   ;
//           ERR_ECR_ERROR     -  ;
//           ERR_END_OF_PAPER  -   ;
//           ERR_INTERNAL      -   ;
//////////////////////////////////////////////////////////////////////////////
{
  unsigned char  txbuf[64],rxbuf[256];
  int            i, j, res, xres, txlen, errs;
  bool           fDocEnd;

  EX_Error = 0;

  if( hCOM==INVALID_HANDLE_VALUE ) return ERR_CONN_CLOSED;

  switch( flag )
  {
    case 0: //---   
    {
       txbuf[0]=2; txbuf[1]=6; txbuf[2]=0; txlen = 3;

       res = SendDataToKKM( 1, txlen, txbuf );
       if( res==ENET_SUCCS ) // ,  
       {
          res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
          if( res==ENET_SUCCS )
          {
            if( rxbuf[2]==0 )
            {
               opcur = 0; DocType=-1;
               return SUCCESS;
            }
            else
            {
               if( rxbuf[2]== ENET_BADMODE )
               {
                  opcur = 0; DocType=-1;
                  return SUCCESS;
               }
               else
               {
                  EX_Error = rxbuf[2];
                  return RecodeErrorKKM( &EX_Error );
               }
            }
          }
          else //---    
          {
             EX_Error = res;
             return RecodeErrorKKM( &EX_Error );   //    
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );   //    
       }
    }
    case 1: //---   
    {
       if( opcur<1 || DocType < 0 || DocType>3 )  return ERR_REC_NOOPEN;

       //*   -  ,      ,
       //*          
       if( DocType==0 && DocData[opcur-1].optype!=12 )
       {
          DocData[opcur].optype=12;   //  ,  
          DocData[opcur].uidop = 0;   //  
          memset( &DocData[opcur].summa[0], 0x0, 7);    //  
          DocData[opcur].opnum = opcur; opcur++;
       }

       i=0;  fDocEnd =false;  errs =0;

       while( i<opcur && i<255 )
       {
         switch( DocData[i].optype )
         {
            case 0: //- 
            {
               memset( txbuf, 0x0, 64 );
               txbuf[0]=2; txbuf[1]=4;
               txbuf[3]=DocData[i].uidop; txbuf[4]=(unsigned char)(i+1);
               memcpy( &txbuf[5], &DocData[i].plu, 3);
               if(txbuf[5]!=0||txbuf[6]!=0||txbuf[7]!=0)LOG("close txbuf[5..7]!=0");else LOG("close txbuf[5..7]==0");
               memcpy( &txbuf[8], &DocData[i].tovname, 32);
               memcpy( &txbuf[40], &DocData[i].summa, 5); //! 40  //az 35
               memcpy( &txbuf[45], &DocData[i].tax, 2 );  //! 45  //az 40
               memcpy( &txbuf[48], &DocData[i].kolvo, 5); //! 48  //az 43
               txlen = 58;
               break;
            }
            case 1: //- 
            {
               memset( txbuf, 0x0, 64 );
               txbuf[0]=2; txbuf[1]=4;
               txbuf[3]=DocData[i].uidop; txbuf[4]=(unsigned char)(i+1);

               memcpy( &txbuf[5], &DocData[i].plu, 3);
               memcpy( &txbuf[8], &DocData[i].tovname, 32);
               memcpy( &txbuf[40], &DocData[i].summa, 5); //!40
               memcpy( &txbuf[45], &DocData[i].tax, 2 );  //!45
               memcpy( &txbuf[48], &DocData[i].kolvo, 5); //!48
               txlen = 58;  fDocEnd = true;
               break;
            }
            case 2: //- 
            {
               txbuf[0]=2; txbuf[1]=7;  txbuf[2]=3;
               memcpy( &txbuf[3], DocData[i].summa, 7 );
               txlen = 10;
               fDocEnd = true;
               break;
            }
            case 3: //- 
            {
               txbuf[0]=2; txbuf[1]=7; txbuf[2]=4;
               memcpy( &txbuf[3], DocData[i].summa, 7 );
               txlen = 10;
               fDocEnd = true;
               break;
            }
            case 10: //- 
            {
               txbuf[0]=2; txbuf[1]=5; txbuf[2]=0xC4;
               txbuf[3]=DocData[i].opnum;
               memcpy( &txbuf[4], DocData[i].summa, 7 );
               txlen = 11;
               break;
            }
            case 11: //- 
            {
               txbuf[0]=2; txbuf[1]=5; txbuf[2]=0xC5;
               txbuf[3]=DocData[i].opnum;
               memcpy( &txbuf[4], DocData[i].summa, 7 );
               txlen = 11;
               break;
            }
            case 12: //- ,  
            {
               txbuf[0]=2; txbuf[1]=7;  txbuf[2]=0;
               if( DocData[i].uidop == 0 ) { txbuf[2]=0; } else txbuf[2]=1;
               memcpy( &txbuf[3], DocData[i].summa, 7 );
               txlen = 10;
               fDocEnd = true; //  
               break;
            }
            default: return ERR_INTERNAL;
         }//* eof switch

         LOG("-----{");
         LOG("SendDataToKKM");
         res = SendDataToKKM( 1, txlen, txbuf );
         if( res==ENET_SUCCS ) // ,  
         {
            LOG("SendDataToKKM OK");

            res=WaitDataFromKKM( 1, 256, &j, &rxbuf[0] );
            if( res==ENET_SUCCS )
            {
             LOG("WaitDataFromKKM OK");
             LOG("-----}");
              if( rxbuf[2]==0 )
              {
                LOG("KKM OK");
                 if( fDocEnd == true )
                 {
                    LOG("Close Check");
                    DocType = -1; opcur = 0;
                    LastDocNum =  *(int*)(rxbuf+5);
                    return SUCCESS;
                 }
//                 Sleep(50);             //    
                 i++;                  // 
              }
              else
              {//---  
                  LOG("KKM error");
                  EX_Error = rxbuf[2];
                  return RecodeErrorKKM( &EX_Error );
              }
            }//---    
            else
            {
               LOG("WaitDataFromKKM Error");
               EX_Error = res;
               return RecodeErrorKKM( &EX_Error );
            }
         }
         else
         {
            errs++;                             //    
            LOG("SendDataToKKM Error");
            if( errs>5 )
            {
               EX_Error = res;
               return RecodeErrorKKM( &EX_Error );
            }
//            Sleep(50);
         }
       }
       return ERR_INTERNAL;  //     
    }//* eof Close Receipt case
  }//* eof switch(flag)
}

int  __stdcall  GetLastDocNum(void)
 {
  int Res=0,mn=1,LastDN=LastDocNum;
  for(int i=1;i<=8;i++)
   {
    Res+=(LastDN&0xf)*mn;
    mn*=10;
    LastDN=LastDN>>4;
   }
  return Res;
 }

int __stdcall Zreport( void )
///////////////////////////////////////////////////////////////////////////////
//   :  	   Z-.
//
//    :
//     SUCCESS          -  
//     ERR_CONN_CLOSED  -     
//     ERR_NO_RESPONSE  -   
//     ERR_REC_OPENED   -   
//     ERR_ECR_ERROR    -  
///////////////////////////////////////////////////////////////////////////////
{
  int  res, ival,i;
  unsigned char txbuf[32],rxbuf[256];

  if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

  res = GetStateKKM( 1, &ival );
  if( res == ENET_SUCCS )
  {
    if( ival != 0 )
    {
       res = ExitFromCashMode();
       if( res!=SUCCESS )
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
    }

    txbuf[0]=2; txbuf[1]=13;  txbuf[2]= 0;
    memset( &txbuf[3], '0', 16 );
    memcpy( &txbuf[3], password, 6 );

    res = SendDataToKKM( 1, 19, &txbuf[0] );
    if( res==ENET_SUCCS ) // ,  
    {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 ) { return SUCCESS; }
            else
            {
                EX_Error = rxbuf[2];
                return RecodeErrorKKM( &EX_Error );
            }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
    }
    else
    {
        EX_Error = res;
        return RecodeErrorKKM( &EX_Error );  //   
    }
  }
  else
  {
     EX_Error = res;
     return RecodeErrorKKM( &EX_Error );
  }
}


int __stdcall Xreport( void )
///////////////////////////////////////////////////////////////////////////////
//   :  	   Z-.
//
//    :
//     SUCCESS          -  
//     ERR_CONN_CLOSED  -     
//     ERR_NO_RESPONSE  -   
//     ERR_REC_OPENED   -   
//     ERR_ECR_ERROR    -  
///////////////////////////////////////////////////////////////////////////////
{
  int  res, ival,i;
  unsigned char txbuf[32],rxbuf[256];

  if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

  res = GetStateKKM( 1, &ival );
  if( res == ENET_SUCCS )
  {
    if( ival != 0 )
    {
       res = ExitFromCashMode();
       if( res!=SUCCESS )
       {
         if( res == ENET_TIMEOUT ) { return ERR_NO_RESPONSE; }
           else return ERR_ECR_ERROR;
       }
    }

    txbuf[0]=2; txbuf[1]=14;  txbuf[2]= 0;
    memset( &txbuf[3], '0', 16 );
    memcpy( &txbuf[3], password, 6 );

    res = SendDataToKKM( 1, 19, &txbuf[0] );
    if( res==ENET_SUCCS ) // ,  
    {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
         if( rxbuf[2]==0 ) { return SUCCESS; }
            else
            {
               EX_Error = rxbuf[2];
               return RecodeErrorKKM( &EX_Error );
            }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
    }
    else
    {
       EX_Error = res;
       return RecodeErrorKKM( &EX_Error );
    }
  }
  else
  {
     EX_Error = res;
     return RecodeErrorKKM( &EX_Error );
  }
}


int __stdcall GetExErrorCode( void )
{
   return EX_Error;
}


int __stdcall QueryEcrIdent(
//////////////////////////////////////////////////////////////////////////////
// :
//	        .
// :
//                31 . (31-)  0x00.
//	ModelName -  ( 'MERCURY-114.1F')
//      Manufacturer  - 
//      FirmvareVersion -   ( '1.0')
///////////////////////////////////////////////////////////////////////////////
    char  *ModelName,
    char  *Manufacturer,
    char  *FirmvareVersion
)
{
   unsigned char txbuf[16],rxbuf[256], *dest;
   int           res,i;

   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=15;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             i=0; dest=ModelName;
             memset( dest,'\0',31);
             while( i<16 && rxbuf[3+i]!='\0') {*dest=rxbuf[3+i];dest++;i++;}

             i=0; dest=FirmvareVersion;
             memset( dest,'\0',31);
             while( i<12 && rxbuf[31+i]!='\0') {*dest=rxbuf[31+i];dest++;i++;}

             dest=Manufacturer;
             memset( dest,'\0',31);
             strncpy( dest, "Incotex", 31);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}
int __stdcall QueryEcrIdentEx(
//////////////////////////////////////////////////////////////////////////////
// :
//	        .
// :
//                31 . (31-)  0x00.
//	ModelName -  ( 'MERCURY-114.1F')
//      Manufacturer  - 
//      FirmvareVersion -   ( '1.0')
//      SN -   
///////////////////////////////////////////////////////////////////////////////
    char  *ModelName,
    char  *Manufacturer,
    char  *FirmvareVersion,
    char  *SN
)
{
   unsigned char txbuf[16],rxbuf[256], *dest;
   int           res,i;

   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=15;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             i=0; dest=ModelName;
             memset( dest,'\0',31);
             while( i<16 && rxbuf[3+i]!='\0') {*dest=rxbuf[3+i];dest++;i++;}

             i=0; dest=FirmvareVersion;
             memset( dest,'\0',31);
             while( i<12 && rxbuf[31+i]!='\0') {*dest=rxbuf[31+i];dest++;i++;}

             i=0; dest=SN;
             memset( dest,'\0',31);
             while( i<12 && rxbuf[19+i]!='\0') {*dest=rxbuf[19+i];dest++;i++;}

             dest=Manufacturer;
             memset( dest,'\0',31);
             strncpy( dest, "Incotex", 31);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}

int __stdcall QueryEcrDateTime( char  *pdatetime)
//////////////////////////////////////////////////////////////////////////////
// :
//                 .
// :
//          DateTime -       
//          (dd.mm.yy hh:mm:ss)
//  :
//            SUCCESS -  .
//	ERR_NO_RESPONSE -   .
//            ERR_INVALID_ARG -  .
//            ERR_CONN_CLOSED -   .
//////////////////////////////////////////////////////////////////////////////
{
   unsigned char txbuf[16],rxbuf[256], *dest, *pch, ch;
   int           res,i;
   const char * term = ".. ::\0";
   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=3;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             pch=&rxbuf[3];  res=0;
             while(res<6)
             {
              byte D = pch[res];
              *pdatetime = '0'+(D>>4);   pdatetime++;
              *pdatetime = '0'+(D&0x0F); pdatetime++;
              *pdatetime = term[res];    pdatetime++;
              res++;
             }
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}
/*int __stdcall QueryEcrDateTime( char  *pdatetime)
//////////////////////////////////////////////////////////////////////////////
// :
//                 .
// :
//          DateTime -       
//          (ddmmyyyyhhmm)
//  :
//            SUCCESS -  .
//	ERR_NO_RESPONSE -   .
//            ERR_INVALID_ARG -  .
//            ERR_CONN_CLOSED -   .
//////////////////////////////////////////////////////////////////////////////
{
   unsigned char txbuf[16],rxbuf[256], *dest, *pch, ch;
   int           res,i;

   EX_Error = 0;
   if( hCOM==INVALID_HANDLE_VALUE && CurrMode<0 ) return ERR_CONN_CLOSED;

   txbuf[0]=2; txbuf[1]=3;  txbuf[2]= 0;
   res = SendDataToKKM( 1, 3, &txbuf[0] );
   if( res==ENET_SUCCS )
   {
       res=WaitDataFromKKM( 1, 256, &i, &rxbuf[0] );
       if( res==ENET_SUCCS )
       {
          if( rxbuf[2]==0 )
          {
             memset( txbuf, '\0', 16 );
             dest = &txbuf[0];  pch=&rxbuf[3];  res=0;
             while( res<3 )
             {
               if( !(res&1) )
               {
                  ch=*pch; ch=ch>>4;
                  *dest=ch+'0';
               }
               else
               {
                  ch=*pch; ch=ch&0x0F;
                  *dest=ch+'0';
                  pch++;
               }
               res++; dest++;
             }

             dest = &txbuf[6];  pch=&rxbuf[6];  res=0;
             while( res<2 )
             {
               if( !(res&1) )
               {
                  ch=*pch; ch=ch>>4;
                  *dest=ch+'0';
               }
               else
               {
                  ch=*pch; ch=ch&0x0F;
                  *dest=ch+'0';
                  pch++;
               }
               res++; dest++;
             }
             memcpy( pdatetime, txbuf, 11);
             return SUCCESS;
          }
          else
          {
             EX_Error = rxbuf[2];
             return RecodeErrorKKM( &EX_Error );
          }
       }
       else
       {
          EX_Error = res;
          return RecodeErrorKKM( &EX_Error );
       }
   }
   else
   {
      EX_Error = res;
      return RecodeErrorKKM( &EX_Error );
   }
}
*/

int __stdcall SynchronazeDateTime(void)
//////////////////////////////////////////////////////////////////////////////
//:
//                .
// :
//            SUCCESS -  .
//	ERR_NO_RESPONSE -   .
//            ERR_CONN_CLOSED -   .
//////////////////////////////////////////////////////////////////////////////
{
   EX_Error = EX_IAE_UNSUPPORTED_OPER_TYPE;
   return ERR_INTERNAL;
}


