//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <math.h>
#include "main_test_dll.h"
#include "drvmercfr.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
   hDLL = NULL;
   cbRate->ItemIndex=1;
   cbCommPort->ItemIndex=0;
   cbDocType->ItemIndex=0;
   cbTax->ItemIndex=0;
   cbDepth->ItemIndex=0;
   cbDiscType->ItemIndex=0;
   cbGetTaxNom->ItemIndex=0;

}//---------------------------------------------------------------------------


void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   FreeLibrary(hDLL);
}//---------------------------------------------------------------------------


void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled=false;
   Timer1->Interval=7000;
   StatusBar1->SimpleText="";
}//---------------------------------------------------------------------------



void __fastcall TForm1::btLoadDllClick(TObject *Sender)
{
   hDLL = LoadLibrary("drvmercfr.dll");
   if( hDLL!=NULL )
   {
     Timer1->Enabled=false;
     StatusBar1->SimpleText="DLL !";
     Timer1->Interval = 7000; Timer1->Enabled=true;
     btConnect->Enabled=true;
   }
   else
   {
     Timer1->Enabled=false;
     StatusBar1->SimpleText="  DLL!";
     Timer1->Interval = 7000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------

void __fastcall TForm1::btConnectClick(TObject *Sender)
{
   int  res,port,rate;
   char psw[10]="00000000";
   TConnect Connect = NULL;

   if( hDLL!=NULL )
   {
     Connect = (TConnect) GetProcAddress(hDLL, "Connect");
     if( Connect != NULL )
     {
        port=cbCommPort->ItemIndex+1;

        switch( cbRate->ItemIndex )
        {
          case 0: { rate=4800; break; }
          case 1: { rate=9600; break; }
          case 2: { rate=19200; break; }
          case 3: { rate=57600; break; }
        }

        strncpy( psw, edPsw->Text.c_str(),6);

        res = (Connect)(port, rate, 800, psw);
        if( res==SUCCESS )
        {
           btRegOp->Enabled=true;
           btXReport->Enabled=true; btZReport->Enabled=true;
           btGetTax->Enabled=true;  cbGetTaxNom->Enabled=true;
           bSendText->Enabled=true;
        }
        else
        {
           Timer1->Enabled=false;
           StatusBar1->SimpleText="  Connect(): "+IntToStr(res);
           Timer1->Interval=7000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled=false;
        StatusBar1->SimpleText=" Connect    DLL!";
        Timer1->Interval=7000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled=false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=7000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------


void __fastcall TForm1::btRegOpClick(TObject *Sender)
{
   int  res;
   TRegisterOper RegisterOper = NULL;

   if( hDLL!=NULL )
   {
     RegisterOper = (TRegisterOper) GetProcAddress(hDLL, "RegisterOper");
     if( RegisterOper != NULL )
     {
        res = (RegisterOper)(1, "no name");
        if( res==SUCCESS )
        {
           btOpenDoc->Enabled=true;
           cbDocType->Enabled=true;
           DocType = -1;               //   

           edPsw->Enabled=true;
           btXReport->Enabled=true;  btZReport->Enabled=true;
           btGetTax->Enabled=true;
        }
        else
        {
           Timer1->Enabled=false;
           StatusBar1->SimpleText="  RegisterOper(): "+IntToStr(res);
           Timer1->Interval=7000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled=false;
        StatusBar1->SimpleText=" RegisterOper    DLL!";
        Timer1->Interval=7000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled=false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=7000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------


void __fastcall TForm1::btOpenDocClick(TObject *Sender)
///////////////////////////////////////////////////////////////////////////////
//
//     
//
///////////////////////////////////////////////////////////////////////////////
{
   int  res;
   TOpenReceipt OpenReceipt = NULL;

   if( hDLL!=NULL )
   {
     OpenReceipt = (TOpenReceipt) GetProcAddress(hDLL, "OpenReceipt");
     if( OpenReceipt != NULL )
     {
        res = (OpenReceipt)( (int) cbDocType->ItemIndex );
        if( res==SUCCESS )
        {
           KolProd = 0;
           DocType = cbDocType->ItemIndex;
           btOpenDoc->Enabled=false;  cbDocType->Enabled=false;
           edPrice->Enabled=true; edPrice->Text="";
           btAddOper->Enabled=true;
           //btAnnDoc->Enabled=true;
           //btCloseDoc->Enabled=true;

           btXReport->Enabled=false; btZReport->Enabled=false;
           btGetTax->Enabled=false;

           switch( DocType )
           {
              case 0:
              {
                 edNameTov->Enabled=true; edNameTov->Text=" ";
                 edKolvo->Enabled=true; edKolvo->Text="";
                 cbTax->Enabled=true;
                 cbDepth->Enabled=true;
                 cbDiscType->Enabled=true;
                 edDiscSum->Enabled=true;
                 btSkdAdd->Enabled=true;
                 break;
              }
              case 1:
              {
                 edNameTov->Enabled=true; edNameTov->Text=" ";
                 edKolvo->Enabled=true; edKolvo->Text="";
                 cbTax->Enabled=false;
                 cbDepth->Enabled=true;
                 cbDiscType->Enabled=false;
                 edDiscSum->Enabled=false;
                 btSkdAdd->Enabled=false;
                 break;
              }
           }
        }
        else
        {
           Timer1->Enabled=false;
           StatusBar1->SimpleText="  OpenReceipt(): "+IntToStr(res);
           Timer1->Interval=7000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled=false;
        StatusBar1->SimpleText=" OpenReceipt()   DLL!";
        Timer1->Interval=7000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled=false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=7000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------


void __fastcall TForm1::btAddOperClick(TObject *Sender)
{
   int     res, prdgt, prdec, kldgt, kldec, Kolvo, dep,tax;
   char    price[16], kolvo[16], tovname[33];
   bool    fRes;
   double  Price;
   TAddRecEntry AddRecEntry = NULL;

   if( hDLL!=NULL )
   {
     AddRecEntry = (TAddRecEntry) GetProcAddress(hDLL, "AddRecEntry");
     if( AddRecEntry != NULL )
     {
        strncpy( tovname, edNameTov->Text.c_str(),32 );
        strncpy( price, edPrice->Text.c_str(), 15 );
        strncpy( kolvo, edKolvo->Text.c_str(), 15 );

        fRes = PrepareStr( price, &prdgt, &prdec);
        if( fRes && prdgt>0 && prdec<=2 )
        {
           Price = atof(price);
           if(prdec>0) Price=Price/pow(10,prdec);

           if( DocType < 2 )
           {//-------- ,  ---------
              fRes = PrepareStr( kolvo, &kldgt, &kldec );
              if( fRes && kldgt>0 && kldec<=3 )
              {
                 Kolvo=atoi(kolvo);
                 dep=cbDepth->ItemIndex+1; tax=cbTax->ItemIndex;
                 res = (AddRecEntry)(Price,Kolvo,kldec,0,dep,tax,0,tovname);
                 if( res==SUCCESS )
                 {
                      KolProd++;
                      btCloseDoc->Enabled=true;
                      btAnnDoc->Enabled=true;
                 }
                 else
                 {
                     Timer1->Enabled=false;
                     StatusBar1->SimpleText="  AddRecEntry(): "+IntToStr(res);
                     Timer1->Interval=7000; Timer1->Enabled=true;
                 }
              }
              else
              {
                 Timer1->Enabled=false;
                 StatusBar1->SimpleText=":  !";
                 Timer1->Interval=7000; Timer1->Enabled=true;
              }
           }
           else
           {//------ ,  ----------

               res = (AddRecEntry)( 0,0,0,Price,0,0,0,tovname);
               if(res==SUCCESS)
               {
                   KolProd++;
                   btCloseDoc->Enabled=true;
                   btAnnDoc->Enabled=true;
               }
               else
               {
                  Timer1->Enabled=false;
                  StatusBar1->SimpleText="  AddRecEntry(): "+IntToStr(res);
                  Timer1->Interval=7000; Timer1->Enabled=true;
               }
           }
        }
        else
        {
           Timer1->Enabled=false;
           StatusBar1->SimpleText=":  !";
           Timer1->Interval=7000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled=false;
        StatusBar1->SimpleText=" AddRecEntry()   DLL!";
        Timer1->Interval=7000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled=false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=7000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------



void __fastcall TForm1::btCloseDocClick(TObject *Sender)
{
  int res;
  TCloseReceipt CloseReceipt = NULL;


   if( hDLL!=NULL )
   {
     CloseReceipt = (TCloseReceipt) GetProcAddress(hDLL, "CloseReceipt");
     if( CloseReceipt != NULL )
     {
        res = CloseReceipt(1);
        if( res==SUCCESS )
        {
           DocType=-1; KolProd=0;
           cbDocType->Enabled=true;  btOpenDoc->Enabled=true;
           btXReport->Enabled=true;  btZReport->Enabled=true;

           edNameTov->Enabled=false;
           edKolvo->Enabled=false;     edPrice->Enabled=false;
           cbTax->Enabled=false;       cbDepth->Enabled=false;
           btAddOper->Enabled=false;
           cbDiscType->Enabled=false;  edDiscSum->Enabled=false;
           btSkdAdd->Enabled=false;
           btAnnDoc->Enabled=false;    btCloseDoc->Enabled=false;
        }
        else
        {
           Timer1->Enabled=false;
           StatusBar1->SimpleText="  CloseReceipt(): "+IntToStr(res);
           Timer1->Interval=7000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled=false;
        StatusBar1->SimpleText=" CloseReceipt()   DLL!";
        Timer1->Interval=7000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled=false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=7000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------

void __fastcall TForm1::btGetTaxClick(TObject *Sender)
{
   int            res,taxval;
   float          val;
   char           name[64], rate[16];


   TGetTaxRate GetTaxRate = NULL;

   if( hDLL!=NULL )
   {
     GetTaxRate = (TGetTaxRate) GetProcAddress(hDLL, "GetTaxRate");
     if( GetTaxRate != NULL )
     {
        res = (GetTaxRate)(cbGetTaxNom->ItemIndex+1, &taxval, name );
        if( res == SUCCESS )
        {
           val = taxval;
           val = val/100;
           //sprintf( rate, "%5.2f" val);
           lbTaxVal->Caption = FloatToStrF(val,0,4,2);
           lbTaxName->Caption = AnsiString(name);    //=name; //.printf(" %s",name);
        }
        else
        {
          lbTaxVal->Caption=""; lbTaxName->Caption="";
          StatusBar1->SimpleText="  GetTaxRate: "+IntToStr(res);
        }
     }
     else StatusBar1->SimpleText=" GetTaxRate    DLL!";
   }
   else StatusBar1->SimpleText="DLL  !";
}//---------------------------------------------------------------------------





bool __fastcall TForm1::PrepareStr(char *pstr, int  *digits, int *pos)
///////////////////////////////////////////////////////////////////////////////
//
//     . ,   
//  ,  ,   -     
//  .
//
///////////////////////////////////////////////////////////////////////////////
{
   int    i, dgt, dec;
   bool   fDec, fStart;
   char   ch;

  fDec=false; fStart=false;
  i=0; dgt=0; dec=0; ch= *pstr;

  while( i<32 && ch!='\0' )
  {
     ch = *(pstr+i);
     if( ch>='0' && ch<='9' )
     {
        fStart=true;
        if( fDec== true ) { dec++; *(pstr+i-1) = ch; }
        dgt++;
     }
     else
     {
        if( ch==' ' || ch=='.' || ch==',' )
        {
          if( ch==' ' && (fStart) ) return false;
          if( (ch=='.' || ch==',')&& (fDec) ) return false;
          if( (ch=='.' || ch==',')&& (!fDec) ) fDec=true;
        }
        else
        {
           if( ch=='\0' && (fDec) ) *(pstr+i-1) = ch;
           if( ch!='\0') return false;
        }
     }
     i++;
  }

  *digits=dgt;  *pos=dec;
  return true;
}


void __fastcall TForm1::btAnnDocClick(TObject *Sender)
{
  int res;
  TCloseReceipt CloseReceipt = NULL;


   if( hDLL!=NULL )
   {
     CloseReceipt = (TCloseReceipt) GetProcAddress(hDLL, "CloseReceipt");
     if( CloseReceipt != NULL )
     {
        res = CloseReceipt(0);
        if( res==SUCCESS )
        {
           DocType=-1; KolProd=0;
           cbDocType->Enabled=true;  btOpenDoc->Enabled=true;
           btXReport->Enabled=true;  btZReport->Enabled=true;

           edNameTov->Enabled=false;
           edKolvo->Enabled=false;     edPrice->Enabled=false;
           cbTax->Enabled=false;       cbDepth->Enabled=false;
           btAddOper->Enabled=false;
           cbDiscType->Enabled=false;  edDiscSum->Enabled=false;
           btSkdAdd->Enabled=false;
           btAnnDoc->Enabled=false;    btCloseDoc->Enabled=false;
        }
        else
        {
           Timer1->Enabled=false;
           StatusBar1->SimpleText="  CloseReceipt(): "+IntToStr(res);
           Timer1->Interval=7000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled=false;
        StatusBar1->SimpleText=" CloseReceipt()   DLL!";
        Timer1->Interval=7000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled=false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=7000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------

void __fastcall TForm1::btSkdAddClick(TObject *Sender)
{
   int     res, smdgt, smdec;
   char    summa[16];
   bool    fRes;
   double  Summa;
   TAddRecAdjust AddRecAdjust = NULL;

   if( hDLL!=NULL )
   {
     AddRecAdjust = (TAddRecAdjust) GetProcAddress(hDLL, "AddRecAdjust");
     if( AddRecAdjust != NULL )
     {
        strncpy( summa, edDiscSum->Text.c_str(),15 );

        fRes = PrepareStr( summa, &smdgt, &smdec);
        if( fRes && smdgt>0 && smdec<=2 && DocType==0 )
        {
           Summa = atof(summa);
           if(smdec>0) Summa=Summa/pow(10,smdec);
           if(cbDiscType->ItemIndex==0 ) Summa = -1*Summa;

           res = (AddRecAdjust)(Summa,"");
           if( res==SUCCESS )
           {
              KolProd++;
           }
           else
           {
              Timer1->Enabled=false;
              StatusBar1->SimpleText="  AddRecEntry(): "+IntToStr(res);
              Timer1->Interval=7000; Timer1->Enabled=true;
           }
        }
        else
        {
           Timer1->Enabled=false;
           StatusBar1->SimpleText=":     !";
           Timer1->Interval=7000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled=false;
        StatusBar1->SimpleText=" AddRecAdjust()   DLL!";
        Timer1->Interval=7000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled=false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=7000; Timer1->Enabled=true;
   }

}//---------------------------------------------------------------------------



void __fastcall TForm1::btXReportClick(TObject *Sender)
{
   int            res;

   TXreport Xreport = NULL;

   if( hDLL!=NULL )
   {
     Xreport = (TXreport) GetProcAddress(hDLL, "Xreport");
     if( Xreport != NULL )
     {
        res = (Xreport)();
        if( res != SUCCESS )
        {
           Timer1->Enabled = false;
           StatusBar1->SimpleText="  Xreport(): "+IntToStr(res);
           Timer1->Interval=5000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled = false;
        StatusBar1->SimpleText=" Xreport   DLL!";
        Timer1->Interval=5000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled = false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=5000; Timer1->Enabled=true;
   }
}//---------------------------------------------------------------------------

void __fastcall TForm1::btZReportClick(TObject *Sender)
{
   int            res;

   TZreport Zreport = NULL;

   if( hDLL!=NULL )
   {
     Zreport = (TZreport) GetProcAddress(hDLL, "Zreport");
     if( Zreport != NULL )
     {
        res = (Zreport)();
        if( res != SUCCESS )
        {
           Timer1->Enabled = false;
           StatusBar1->SimpleText="  Zreport(): "+IntToStr(res);
           Timer1->Interval=5000; Timer1->Enabled=true;
        }
     }
     else
     {
        Timer1->Enabled = false;
        StatusBar1->SimpleText=" Zreport   DLL!";
        Timer1->Interval=5000; Timer1->Enabled=true;
     }
   }
   else
   {
      Timer1->Enabled = false;
      StatusBar1->SimpleText="DLL  !";
      Timer1->Interval=5000; Timer1->Enabled=true;
   }

}//---------------------------------------------------------------------------

void __fastcall TForm1::bSendTextClick(TObject *Sender)
{
   int  res;
   TSendText SendText = NULL;
   char b[32];
//   AnsiString s=
   strncpy(b,eSend->Text.c_str(),32);
   CharToOem(b,b);
   if( hDLL!=NULL )
   {
     SendText = (TSendText) GetProcAddress(hDLL, "SendText");
     if( SendText != NULL )
     {
        res = (SendText)(b);
        if( res==SUCCESS )
        {
        ShowMessage("Ok");
        }else ShowMessage(AnsiString("Er. fun:")+IntToStr(res));
     }else ShowMessage("Er. not found fun");
   }else ShowMessage("Er. not loaded DLL");  

}
//---------------------------------------------------------------------------

