//---------------------------------------------------------------------------

#ifndef UnitMainH
#define UnitMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "drvmercfr.h"
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TMemo *Log;
        TLabel *Label7;
        TComboBox *cbComPort;
        TLabel *Label2;
        TComboBox *cbSpeedPort;
        TButton *bConnect;
        TButton *bDisConnect;
        TEdit *ePassword;
        TLabel *Label1;
        TButton *bAdd;
        TButton *bInfo;
        TButton *bRegOper;
        TButton *bClose;
        TButton *bOpen;
        TButton *bTEST;
        TButton *bCancelCheck;
        TEdit *eAddCount;
        TCheckBox *cbTop;
        TLabel *Label3;
        TEdit *eTimeOut;
        TButton *Pay;
        TComboBox *ComboBoxPayType;
        TButton *Adjust;
        TCheckBox *cbAdjust;
        void __fastcall FormActivate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall bConnectClick(TObject *Sender);
        void __fastcall bDisConnectClick(TObject *Sender);
        void __fastcall bAddClick(TObject *Sender);
        void __fastcall bInfoClick(TObject *Sender);
        void __fastcall bRegOperClick(TObject *Sender);
        void __fastcall bCloseClick(TObject *Sender);
        void __fastcall bOpenClick(TObject *Sender);
        void __fastcall bTESTClick(TObject *Sender);
        void __fastcall bCancelCheckClick(TObject *Sender);
        void __fastcall cbTopClick(TObject *Sender);
        void __fastcall PayClick(TObject *Sender);
        void __fastcall AdjustClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        HINSTANCE hDLL;
        TConnect          Connect;
        TDisconnect       Disconnect;
        TQueryEcrIdent    QueryEcrIdent;
        TQueryEcrIdentEx  QueryEcrIdentEx;
        TOpenReceipt      OpenReceipt;
        TAddPay           AddPay;
        TCloseReceipt     CloseReceipt;
        TAddRecEntry      AddRecEntry;
        TRegisterOper     RegisterOper;
        TGetExErrorCode   GetExErrorCode;
        TGetLastDocNum    GetLastDocNum;
        TAddRecAdjust     AddRecAdjust;
        TGetTaxNum        GetTaxNum;
        TQueryEcrDateTime QueryEcrDateTime;
        bool ExistError;
        __fastcall TForm1(TComponent* Owner);

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
